import { getToken } from '@/utils/auth'
import { Message } from 'element-ui'
import NProgress from 'nprogress'
import 'nprogress/nprogress.css'
import router from './router'
import store from './store'
import Cookies from 'js-cookie'
NProgress.configure({ showSpinner: false })

const whiteList = ['/login', '/register','/401','/staff/profile','/yibaomanager/outpatient','/yibaomanager/outpatientTwo','/yibaomanager/outpatientTwoSFC','/yibaomanager/refound','/yibaomanager/refoundSFC','/yibaomanager/patientInfo','/yibaomanager/dwText','/yibaomanager/outpatientCharging','/yibaomanager/outpatientYfang']
router.beforeEach((to, from, next) => {
    NProgress.start()
    var reg = new RegExp('(^|&)' + 'token' + '=([^&]*)(&|$)')
            var r = window.location.search.substr(1).match(reg)
            if (r != null) {
                localStorage.setItem('SET_TOKEN', 'Bearer '+unescape(r[2]))
                Cookies.set('Admin-Token', 'Bearer '+unescape(r[2]))
            }
    if (getToken()||localStorage.getItem('SET_TOKEN')) {
        to.meta.title && store.dispatch('settings/setTitle', to.meta.title)
        /* has token*/
        if (to.path === '/login') {
            next({ path: '/' })
            NProgress.done()
        } else {
            if (store.getters.groups.length === 0) {
                // 判断当前用户是否已拉取完user_info信息
                store.dispatch('GetInfo')
                    .then(() => {
                        store.dispatch('GenerateRoutes').then(accessRoutes => {
                            // 根据roles权限生成可访问的路由表
                            router.addRoutes(accessRoutes) // 动态添加可访问路由表
                            next({ ...to, replace: true }) // hack方法 确保addRoutes已完成
                        })
                    })
                    .catch(err => {
                        // store.dispatch('LogOut').then(() => {

                        //     console.error(err)
                        //     next({ path: '/' })
                        // })
                    })
            } else {
                next()
            }
        }
    } else {
        // 没有token
        if (whiteList.indexOf(to.path)!== -1) {
            // 在免登录白名单，直接进入
            next()
        } else {
            next(`/login?redirect=${to.fullPath}`) // 否则全部重定向到登录页
            NProgress.done()
        }
    }
})

router.afterEach(() => {
    NProgress.done()
})
